/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * cmemoѤΤޤޤʴؿ
 */

/*
 * Cmemo : Text Editor
 * misc.c - source file for various function of cmemo
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include "cme_def.h"
#include "cmemo.h"
#include "cme_misc.h"

#define ALM_RCV_DONE 0
#define ALM_RCV_WAIT 1

static int search_visi_flag = 0; /* 0:ɽ 1:ɽ */
static int alarm_rcv_flag = ALM_RCV_DONE; /* 顼Ԥե饰 */
static GtkWidget *message_entry = NULL;

/* Хåؿϡ0(FALSE)֤Ȥˤäƥ٥Ȥ */
/* ã³ԤǥեȤư򤵤Ǥ롣٥ */
/* Ȥߤ᤿ϡ1(TRUE)֤                      */

void init_mlwrite(GtkWidget *msg_entry)
{
  if (msg_entry != NULL) {
    message_entry = msg_entry;
  }
  return;
}

/**************************************
   å饤˥åɽ
 **************************************/
void mlwrite(char *text, int flag)
{
  static gint line_dsp_flag = 1;


  /* ޥɤȯԤƤֹɽι򤷤ʤ */
  if ((line_dsp_flag == 0) && (flag == DELAY_UPDATING)) {
    line_dsp_flag = 1;
    return;
  }

  if (flag != DELAY_UPDATING) {
    line_dsp_flag = 0;
  }

  if (message_entry == NULL) {
    printf("message_entry is null\n");
  }
  else {
    gtk_entry_set_text(GTK_ENTRY(message_entry), text);
  }

  return;
}

/*******************************
   (ޤ̤б 2000/10/02)
 *******************************/
void print_cb(GtkWidget *widget, gpointer data)
{
  mlwrite("SORRY! \"PRINT\" IS NOT SUPPORTED!", 0);
  return;
}

/**********
   ԡ
 **********/
int edit_copy(GtkWidget *widget, gpointer data)
{
  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ */
    /* ˥塼 Copy ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ */
    /* ǥΤ륦åȤФư褦ˤ롣 */
    gtk_editable_copy_clipboard(GTK_EDITABLE(cm_focused_editable));
  }
  else {
    gtk_editable_copy_clipboard(GTK_EDITABLE((GtkWidget *)data));
  }
  return(0);
}

/************
   ڤ
 ************/
int edit_cut(GtkWidget *widget, gpointer data)
{
  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ */
    /* ˥塼 Cut ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ  */
    /* ǥΤ륦åȤФư褦ˤ롣 */
    gtk_editable_cut_clipboard(GTK_EDITABLE(cm_focused_editable));
  }
  else {
    gtk_editable_cut_clipboard(GTK_EDITABLE((GtkWidget *)data));
  }
  return(0);
}

/************
   Žդ
 ************/
int edit_paste(GtkWidget *widget, gpointer data)
{
  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ  */
    /* ˥塼 Paste ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ */
    /* ǥΤ륦åȤФư褦ˤ롣  */
    gtk_editable_paste_clipboard(GTK_EDITABLE(cm_focused_editable));
  }
  else {
    gtk_editable_paste_clipboard(GTK_EDITABLE((GtkWidget *)data));
  }
  return(0);
}

/************
   
 ************/
void select_all_cb(GtkWidget *widget, gpointer data)
{
  gtk_editable_select_region(GTK_EDITABLE(cm_focused_editable), 0, -1);
  /*gtk_editable_select_region(GTK_EDITABLE(current_document->textbox), 0, 
			     gtk_text_get_length(GTK_TEXT(current_document->textbox)));*/
  return;
}

/*******************
   entry
 *******************/
gint entry_select_all_cb(GtkWidget *widget, gpointer data)
{
  gtk_editable_select_region(GTK_EDITABLE(widget),
                             0,
                             strlen(gtk_entry_get_text(GTK_ENTRY(widget))));
  return(FALSE);
}

/**********************************************
   ߥեΤ륦åȤ򵭲
 **********************************************/
gint editable_focus_in_cb(GtkWidget *widget, gpointer data)
{
  cm_focused_editable = widget;
  return(FALSE);
}

/**********************
   Сɽ
 **********************/
void version_cb(GtkWidget *widget, gpointer data)
{
  mlwrite(VERSION_INFO, 0);
  return;
}

/**************************************
   ݥåץåץ˥塼ݥåץå
 **************************************/
gboolean popup_menu_cb(GtkWidget *widget, GdkEvent *event)
{
  if (event->type == GDK_BUTTON_PRESS) {
    GdkEventButton *bevent = (GdkEventButton *)event;
    if (bevent->button == 3) {
      gtk_menu_popup(GTK_MENU(widget), NULL, NULL, NULL, NULL,
                     bevent->button, bevent->time);
      return TRUE;
    }
  }
  return FALSE;
}

/*********************************
   ʸΰɽ/ɽ
 *********************************/
void search_visi_cb(GtkWidget *widget, gpointer data)
{
  if (search_visi_flag == 0) {
    gtk_widget_show(cm_search.button_up);
    gtk_widget_show(cm_search.button_dn);
    gtk_widget_show(cm_search.entry);
    gtk_widget_grab_focus(cm_search.entry);
    search_visi_flag = 1;
  }
  else {
    gtk_widget_hide(cm_search.button_up);
    gtk_widget_hide(cm_search.button_dn);
    gtk_widget_hide(cm_search.entry);
    gtk_widget_grab_focus(current_document->textbox);
    search_visi_flag = 0;
  }
}

/**************************
   ʸΰɽ
 **************************/
void search_open_cb(GtkWidget *widget, gpointer data)
{
  gtk_widget_show(cm_search.button_up);
  gtk_widget_show(cm_search.button_dn);
  gtk_widget_show(cm_search.entry);
  gtk_widget_grab_focus(cm_search.entry);
  search_visi_flag = 1;

  return;
}

/***************************
   ¹cmemoο֤
 ***************************/
int count_opened_cmemo(void)
{
  FILE *fp;
  char buf[256];
  int cmemo_count;

  cmemo_count = 0;

#if OPENBSD
  if ((fp = popen("ps -a", "r")) != NULL) {
#else
  if ((fp = popen("ps -A", "r")) != NULL) {
#endif
    while (fgets(&buf[0], sizeof(buf), fp) != NULL) {
      if (strstr(&buf[0], "cmemo") != NULL) {
        cmemo_count++;
      }
    }
    pclose(fp);
  }
  else {
    perror("popen");
    return(-1);
  }
  return(cmemo_count);
}

/***********************************
   SIGALRMФ륳Хåؿ
 ***********************************/
void cme_sig_alarm(int sig)
{
  alarm_rcv_flag = ALM_RCV_DONE;
  signal(SIGALRM, cme_sig_alarm);
  return;
}

/******************************************************
   ¹ΥץƤեå
 ******************************************************/
int cme_file_check(char *chr_chk_pid, char *chr_cme_pid,
                   char *filename, char *command)
{
  pid_t own_pid;
  pid_t chk_pid;
  char kill_buf[256];
  char opened_file[512];

  own_pid = getpid();

  sprintf(&kill_buf[0], "-QF%s", chr_cme_pid);
  chk_pid = (pid_t)atoi(chr_chk_pid);
  if (write_shared_mem(&kill_buf[0]) == 0) {
    if (own_pid != chk_pid) {
      alarm_rcv_flag = ALM_RCV_WAIT;
      kill(chk_pid, SIGUSR1);
    }
    else {
      return(0);
    }
    /* debug */
    /*printf("chk_pid : %d\n", chk_pid);*/
    /*printf("filename : %s\n", filename);*/

    /* λǤޤ顼ॷʥμԤǤäϡ */
    /* pause() ˤä OS ֤¹ԥץؤ */
    /* 褦ˤ롣(ͳϿԲ˽񤤤Ƥ)         */
    if (alarm_rcv_flag == ALM_RCV_WAIT) {
      /* 1Ԥ(SIGALRMƤϤ) */
      alarm(1);
      pause();
      alarm_rcv_flag = ALM_RCV_DONE;
    }
    /* ö֤ */
    /*while (gtk_events_pending()) {
      gtk_main_iteration();
    }*/
    /* ʳ᤯ʥãȶͭν񤭴餷 */
    /* Ȥ⥷ʥOSΥåؤΤ...  */

    /* LinuxǤϥʥǼ¹Υץؤ褦 */
    /* SolarisǤŪOS֤¾Υץؤʤ */
    /* ͭν񤭴˰ʲνäƤޤ...   */

    if (read_shared_mem(&opened_file[0]) == 0) {
      /*printf("filename     : %s\n", filename);*/
      /*printf("rev filename : %s\n", &opened_file[0]);*/
      if (strcmp(&opened_file[0], filename) == 0) {
        /* debug */
        /*printf("rev filename : %s\n", &opened_file[0]);*/
        if (write_shared_mem(command) == 0) {
          /*printf("do kill : %s\n", command);*/
          kill(chk_pid, SIGUSR1);
        }
        return(1);
      }
    }
  }

  return(0);
}

/**********************************
   ¹Υץå
 **********************************/
int check_process(char *cme_pid, char *filename, char *command)
{
  FILE *fp;
  char buf[256];
  int cmemo_count;
  char elements[4][64];
  int i;
  int pid_index;
  int file_check_rtn;

  cmemo_count = 0;
  pid_index = -1;

#if OPENBSD
  if ((fp = popen("ps -a", "r")) != NULL) {
#else
  if ((fp = popen("ps -A", "r")) != NULL) {
#endif
    fgets(&buf[0], sizeof(buf), fp);
    sscanf(&buf[0],
           "%s %s %s %s",
           &elements[0][0],
           &elements[1][0],
           &elements[2][0],
           &elements[3][0]);
    for (i = 0; i < 4; i++) {
      if (strcmp(&elements[i][0], "PID") == 0) {
        pid_index = i;
        break;
      }
    }

    /*if (pid_index == -1) {
      pclose(fp);
      return(-1);
    }*/

    /* Ū0Ȥ */
    pid_index = 0;

    while (fgets(&buf[0], sizeof(buf), fp) != NULL) {
      /*printf("%s", &buf[0]);*/
      sscanf(&buf[0],
             "%s %s %s %s",
             &elements[0][0],
             &elements[1][0],
             &elements[2][0],
             &elements[3][0]);
      if (strstr(&buf[0], "cmemo") != NULL) {
        cmemo_count++;
        file_check_rtn = cme_file_check(&elements[pid_index][0],
                                        cme_pid,
                                        filename,
                                        command);
        if (file_check_rtn > 0) {
          pclose(fp);
          return(cmemo_count);
        }
      }
    }
    pclose(fp);
  }
  else {
    perror("popen");
    return(-1);
  }
  return(0);
}

/***************************************************************
   cme_def.hƤʸɤǤʸ򥫥Ȥ
 ***************************************************************/
int get_char_count(unsigned char *buf, int loop_cnt, int *rtn_cnt, int *rtn_pos_array)
{
  int i;
  int char_count;
  int tmp_rtn_cnt;

  char_count = 0;
  tmp_rtn_cnt = 0;
  /* ʸ򥫥Ȥ */
  for (i = 0; i < loop_cnt; i++) {
    /* ĤʸƬΰ(ʸ)Ǽ */
    /* ƬΥХȿǤϤʤȤդ뤳   */
    if ((int)*buf == (int)'\n') {
      if (tmp_rtn_cnt < MAX_LINE_COUNT) {
        tmp_rtn_cnt++;
        if (rtn_pos_array != NULL) {
          *rtn_pos_array = char_count;
          rtn_pos_array++;
        }
      }
    }
#if CME_EUC
    /* EUC(ХʸǤϤʤ)Ƚ */
    if ((int)*buf > 0x7F) {
      if ((int)*buf != 0x8F) {
        buf++;
        i++;
      }
      else {
        buf++;
        buf++;
        i++;
        i++;
      }
    }
#else
#if CME_UTF8_CJK
    /* UTF-8(CJK:3Хʸ)Ƚ */
    if ((int)*buf > 0x7F) {
      buf++;
      buf++;
      i++;
      i++;
    }
#else
/*
#if 

#else

#endif
*/
#endif /* UTF8_CJK */
#endif /* EUC */
    buf++;
    char_count++;
  }
  if (rtn_cnt != NULL) {
    *rtn_cnt = tmp_rtn_cnt;
  }
  return(char_count);
}
