/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ᥤؿŪԽΤδؿ
 * ƼؿƤӽФδؿ              
 */

/*
 * Cmemo : Text Editor
 * cmemo.h - header file for main source
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


typedef struct thefilestruct {
    gchar *filename;
    gint modified;
    unsigned del_txt_id; /* Copyright (C) 1998 Andy C. Kahn <kahn@zk3.dec.com> */
    unsigned ins_txt_id; /* undo/redo part is copied from gnotepad code */
    GList *undolist;
    GList *undotail;
    GList *redolist;
    GList *redotail;
    GtkWidget *textbox;
    unsigned int line_ins_id; /* stamura (2001/11/22) */
    unsigned int line_del_id; /* stamura (2001/11/22) */
} filestruct;

struct search_struct {
  GtkWidget *button_up;
  GtkWidget *button_dn;
  GtkWidget *entry;
};

struct jump_struct {
  GtkWidget *button;
  GtkWidget *entry;
};

/* Хѿ */
extern GtkWidget *cm_window;
extern GtkWidget *cm_menu_bar;
extern GtkWidget *cm_gsearch_wnd;
extern GtkWidget *cm_focused_editable;
extern GdkFont *cm_keyword_font; /* ѤΥե */
extern GdkFont *cm_normal_font;  /* ̤ʸѤΥե */
extern int cm_end_flag;
extern filestruct *current_document;
extern struct search_struct cm_search;
extern struct jump_struct cm_jump;

/*ؿ*/
int main_win_destroy(GtkWidget *widget, gpointer data);
int read_shared_mem(char *data);
int write_shared_mem(char *data);
