/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ƥȥåΤδؿ
 *
 * ----ѹ---------------------------------------------
 * SDIץꥱˤ뤿ɬפʬκ   
 * -------------------------------------------------------
 */

/********************************************************************
   copied from bluefish-0.3.2 code, modified for use in Cmemo  
   modifications (C) 2000, 2001 Seiji Tamura stamura@mc.neweb.ne.jp
 ********************************************************************/

/*
 * Copyright (C) 1998 Olivier Sessink and Chris Mazuc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "document.h"
#include "undo.h"
#include "ini_file.h"


void flush_queue(void)
{
  while (gtk_events_pending ()) {
    gtk_main_iteration ();
  }
  while (gdk_events_pending ()) {
    gdk_flush ();
  }
}

void destroy_current_document(void)
{
  if (current_document != NULL) {
    if (current_document->filename != NULL) {
      /*g_free (current_document->filename);*/
    }
    g_free (current_document);
  }
  else {
  }
}

filestruct * new_document(void)
{
  filestruct *doc;

  /* Here we create a new document */

  doc = g_malloc0 (sizeof (filestruct));

  doc->textbox = gtk_text_new (NULL, NULL);
  if ((cm_tab_width > 0) && (cm_tab_width <= 16)) {
    GTK_TEXT(doc->textbox)->default_tab_width = cm_tab_width;
  }
  else {
    GTK_TEXT(doc->textbox)->default_tab_width = 8;
  }

  GTK_TEXT(doc->textbox)->tab_stops =
                 g_list_remove(GTK_TEXT(doc->textbox)->tab_stops,
                               GTK_TEXT(doc->textbox)->tab_stops->data);
  GTK_TEXT(doc->textbox)->tab_stops =
                 g_list_remove(GTK_TEXT(doc->textbox)->tab_stops,
                               GTK_TEXT(doc->textbox)->tab_stops->data);
  GTK_TEXT (doc->textbox)->tab_stops = NULL;
  if ((cm_tab_width > 0) && (cm_tab_width <= 16)) {
    GTK_TEXT(doc->textbox)->tab_stops =
             g_list_prepend (GTK_TEXT(doc->textbox)->tab_stops, (void *)cm_tab_width);
    GTK_TEXT(doc->textbox)->tab_stops =
             g_list_prepend (GTK_TEXT(doc->textbox)->tab_stops, (void *)cm_tab_width);
  }
  else {
    GTK_TEXT(doc->textbox)->tab_stops =
             g_list_prepend(GTK_TEXT(doc->textbox)->tab_stops, (void *)8);
    GTK_TEXT(doc->textbox)->tab_stops =
             g_list_prepend(GTK_TEXT(doc->textbox)->tab_stops, (void *)8);
  }
  gtk_text_set_editable (GTK_TEXT (doc->textbox), TRUE);
  gtk_text_set_word_wrap (GTK_TEXT (doc->textbox), FALSE);


  doc->modified = FALSE;
  doc->filename = NULL;

  /*
   * this used to be the signal, but I'll put this in doc_insert_text_cb
   * and doc_delete_text_cb 
   */
  /* gtk_signal_connect(GTK_OBJECT(doc->textbox), "key_press_event",
     textbox_key_press, NULL);   */
  /* this part is copied from gnotepad code 
     Copyright (C) 1998 Andy C. Kahn <kahn@zk3.dec.com> */
  doc->ins_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                       GTK_SIGNAL_FUNC(doc_insert_text_cb), doc);
  doc->del_txt_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                       GTK_SIGNAL_FUNC(doc_delete_text_cb), doc);

  /*******************************************************
     Կɽʤɤ˴ؤؿ³ stamura (2001/11/22)
   *******************************************************/
  doc->line_ins_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "insert_text",
                                        GTK_SIGNAL_FUNC(line_count_insert), doc);
  doc->line_del_id = gtk_signal_connect(GTK_OBJECT(doc->textbox), "delete_text",
                                        GTK_SIGNAL_FUNC(line_count_delete), doc);

  /* set this new document as active notebook page */
  flush_queue ();

  return doc;
}


/*
 * 岼ˡդʸإפ٤δؿ
 *
 * ----ѹ---------------------------------------------
 * ͤ void ѹ
 * 顼åɽˡѹ
 * -------------------------------------------------------
 */

/********************************************************************
   copied from gnotepad+-1.1.4 code, modified for use in Cmemo  
   modifications (C) 2000, 2001 Seiji Tamura stamura@mc.neweb.ne.jp
 ********************************************************************/

/* 
 * Copyright (C) 1998 Andy C. Kahn <kahn@zk3.dec.com>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

void scrollbar_update(GtkText *txt, int tl, int ln) /* tl Կ */
{                                                   /* ln ȯʸι */
  float value;

  if (tl < 3) {
    return;
  }

  if (ln > tl) {
    printf(" File only has %d lines! ", tl);
    return;
  }

  value = (ln * GTK_ADJUSTMENT(txt->vadj)->upper) /
           tl - GTK_ADJUSTMENT(txt->vadj)->page_increment;

  gtk_adjustment_set_value(GTK_ADJUSTMENT(txt->vadj), value);
  return;
} /* scrollbar_update */
