/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * եΥץ󥻡֤˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * files.h - header file for loading or saving files
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#define BIN_FORMAT 61
#define FTYPE_INFO_MAX 20
#define KMODE_INFO_MAX 10
#define CME_READ_LIMIT (1024*1024)

struct ftype_info {       /* ˤĤƤϥĶʬ̵뤹  */
  int data_flag;          /* ι¤ΤΥǡͭɤΥե饰    */
  int enabled;            /* ˥塼Ѳǽˤ뤫ɤΥե饰    */
  int mode_id;            /* ⡼ɤ̤뤿ο                  */
  char title[32];         /* ˥塼ɽ륿ȥ                  */
  char mode[32];          /* ⡼ɤɽʸ c-modeʤ               */
  char ext[32];           /* ⡼ɤбĥ ".c;.h"ʤ          */
  char acckey;            /* Shift+Alt+keyΥ졼           */
  char delimiter[32];     /* ȡڤʬݤΥѥ졼ʸ      */
  int ignore_case;        /* Ƚκݤ硿ʸ̵뤹뤫  */
  char key1buf[1024];     /* ɣХåե "if;for;do;"ʤ       */
  char key2buf[1024];     /* ɣХåե "#include;#define"ʤ */
  char cmt_start[8];      /* ȳʸ                            */
  char cmt_end[8];        /* Ƚλʸ                            */
  char line_cmt[8];       /* ԥ "//"ʤ                         */
  char str_start;         /* ʸ󳫻ʸ                              */
  char str_end;           /* ʸλʸ                              */
  char chr_start;         /* ʸʸ                                */
  char chr_end;           /* ʸλʸ                                */
  char esc_chr;           /* ʸ                              */
  GdkColor base_color;    /* ١顼             :  base_color  */
  GdkColor key1_color;    /* ɥ顼       :  key1_color  */
  GdkColor key2_color;    /* ɥ顼       :  key2_color  */
  GdkColor num_color;     /* ͥ顼               :  num_color   */
  GdkColor cmt_color;     /* ȥ顼           :  cmt_color   */
  GdkColor str_color;     /* ʸ󥫥顼             :  str_color   */
};

struct kmode_info {       /* ˤĤƤϥĶʬ̵뤹  */
  int data_flag;          /* ι¤ΤΥǡͭɤΥե饰    */
  int enabled;            /* ˥塼Ѳǽˤ뤫ɤΥե饰    */
  int mode_id;            /* ⡼ɤ̤뤿ο                  */
  char title[32];         /* ˥塼ɽ륿ȥ                  */
};

struct file_open {
  GtkWidget *open_dlg;
  /* filenametmpfilename󥵥ƱˤʤȤʤ */
  gchar filename[MAX_PATH];
  gchar tmpfilename[MAX_PATH];
};

extern int cm_input_mode; /* ϥ⡼(C C++ etc)(cm_ft_inf[]ֹ) */
extern int cm_kanji_mode; /* ⡼(euc-jp etc)(cm_km_inf[]ֹ) */
extern int cm_return_mode; /* ʸμ(CR LF CRLF)ɽХѿ */

/* ե륿פӥ⡼ɤ빽¤ */
extern struct ftype_info cm_ft_inf[FTYPE_INFO_MAX];

/* ⡼ɤ빽¤ */
extern struct kmode_info cm_km_inf[KMODE_INFO_MAX];

void set_kanji_mode(GtkWidget *widget, gpointer mode);
void set_return_mode(GtkWidget *widget, gpointer mode);
void file_open(gpointer text, gchar *fname);
void what_file(GtkWidget *widget, gpointer text);
int ok_cb_open(GtkWidget *widget, gpointer text, gchar *filename, int file_type);
void ok_cb_save(GtkWidget *widget, gpointer text);
void cancel_cb(GtkWidget *widget, gpointer text);
void destroy_cb(GtkWidget *widget, gpointer text);
void open_text(GtkWidget *widget, gpointer text);
void save_text(GtkWidget *widget, gpointer text);
void save_as_text(GtkWidget *widget, gpointer text);
void open_bad_code(gpointer text, unsigned char *fname);
void open_hex(gpointer text, unsigned char *fname);
void new_window(GtkWidget *widget, gpointer text);
